---
title: MediaTrackSupportedConstraints
slug: Web/API/MediaTrackSupportedConstraints
tags:
  - API
  - Capture
  - Constraints
  - Dictionary
  - Interface
  - Media Capture and Streams API
  - Media Streams API
  - MediaTrackSupportedConstraints
  - Reference
  - Screen Capture
  - Screen Capture API
  - screen
---
<div>{{APIRef("Media Capture and Streams")}}</div>

<p>The <strong><code>MediaTrackSupportedConstraints</code></strong> dictionary establishes the list of constrainable properties recognized by the {{Glossary("user agent")}} or browser in its implementation of the {{domxref("MediaStreamTrack")}} object. An object conforming to <code>MediaTrackSupportedConstraints</code> is returned by {{domxref("MediaDevices.getSupportedConstraints()")}}.</p>

<p>Because of the way interface definitions in WebIDL work, if a constraint is requested but not supported, no error will occur. Instead, the specified constraints will be applied, with any unrecognized constraints stripped from the request.That can lead to confusing and hard to debug errors, so be sure to use <code>getSupportedConstraints()</code> to retrieve this information before attempting to establish constraints if you need to know the difference between silently ignoring a constraint and a constraint being accepted.</p>

<p>An actual constraint set is described using an object based on the {{domxref("MediaTrackConstraints")}} dictionary.</p>

<p>To learn more about how constraints work, see <a href="/en-US/docs/Web/API/Media_Streams_API/Constraints">Capabilities, constraints, and settings</a>.</p>

<h2 id="Properties">Properties</h2>

<p>Some combination—but not necessarily all—of the following properties will exist on the object.</p>

<dl>
 <dt>{{domxref("MediaTrackSupportedConstraints.autoGainControl", "autoGainControl")}}</dt>
 <dd>A Boolean whose value is <code>true</code> if the <code><a href="/en-US/docs/Web/API/MediaTrackConstraints#autoGainControl">autoGainControl</a></code> constraint is supported in the current environment.</dd>
 <dt>{{domxref("MediaTrackSupportedConstraints.width", "width")}}</dt>
 <dd>A Boolean value whose value is <code>true</code> if the <code><a href="/en-US/docs/Web/API/MediaTrackConstraints#width">width</a></code> constraint is supported in the current environment.</dd>
 <dt>{{domxref("MediaTrackSupportedConstraints.height", "height")}}</dt>
 <dd>A Boolean value whose value is <code>true</code> if the <code><a href="/en-US/docs/Web/API/MediaTrackConstraints#height">height</a></code> constraint is supported in the current environment.</dd>
 <dt>{{domxref("MediaTrackSupportedConstraints.aspectRatio", "aspectRatio")}}</dt>
 <dd>A Boolean value whose value is <code>true</code> if the <code><a href="/en-US/docs/Web/API/MediaTrackConstraints#aspectRatio">aspectRatio</a></code> constraint is supported in the current environment.</dd>
 <dt>{{domxref("MediaTrackSupportedConstraints.frameRate", "frameRate")}}</dt>
 <dd>A Boolean value whose value is <code>true</code> if the <code><a href="/en-US/docs/Web/API/MediaTrackConstraints#frameRate">frameRate</a></code> constraint is supported in the current environment.</dd>
 <dt>{{domxref("MediaTrackSupportedConstraints.facingMode", "facingMode")}}</dt>
 <dd>A Boolean value whose value is <code>true</code> if the <code><a href="/en-US/docs/Web/API/MediaTrackConstraints#facingMode">facingMode</a></code> constraint is supported in the current environment.</dd>
 <dt>{{domxref("MediaTrackSupportedConstraints.resizeMode", "resizeMode")}}</dt>
 <dd>A Boolean value whose value is <code>true</code> if the <code><a href="/en-US/docs/Web/API/MediaTrackConstraints#facingMode">resizeMode</a></code> constraint is supported in the current environment.</dd>
 <dt>{{domxref("MediaTrackSupportedConstraints.volume", "volume")}}</dt>
 <dd>A Boolean value whose value is <code>true</code> if the <code><a href="/en-US/docs/Web/API/MediaTrackConstraints#volume">volume</a></code> constraint is supported in the current environment.</dd>
 <dt>{{domxref("MediaTrackSupportedConstraints.sampleRate", "sampleRate")}}</dt>
 <dd>A Boolean value whose value is <code>true</code> if the <code><a href="/en-US/docs/Web/API/MediaTrackConstraints#sampleRate">sampleRate</a></code> constraint is supported in the current environment.</dd>
 <dt>{{domxref("MediaTrackSupportedConstraints.sampleSize", "sampleSize")}}</dt>
 <dd>A Boolean value whose value is <code>true</code> if the <code><a href="/en-US/docs/Web/API/MediaTrackConstraints#sampleSize">sampleSize</a></code> constraint is supported in the current environment.</dd>
 <dt>{{domxref("MediaTrackSupportedConstraints.echoCancellation", "echoCancellation")}}</dt>
 <dd>A Boolean value whose value is <code>true</code> if the <code><a href="/en-US/docs/Web/API/MediaTrackConstraints#echoCancellation">echoCancellation</a></code> constraint is supported in the current environment.</dd>
 <dt>{{domxref("MediaTrackSupportedConstraints.latency", "latency")}}</dt>
 <dd>A Boolean value whose value is <code>true</code> if the <code><a href="/en-US/docs/Web/API/MediaTrackConstraints#latency">latency</a></code> constraint is supported in the current environment.</dd>
 <dt>{{domxref("MediaTrackSupportedConstraints.noiseSuppression", "noiseSuppression")}}</dt>
 <dd>A Boolean whose value is <code>true</code> if the <code><a href="/en-US/docs/Web/API/MediaTrackConstraints#noiseSuppression">noiseSuppression</a></code> constraint is supported in the current environment.</dd>
 <dt>{{domxref("MediaTrackSupportedConstraints.channelCount", "channelCount")}}</dt>
 <dd>A Boolean value whose value is <code>true</code> if the <code><a href="/en-US/docs/Web/API/MediaTrackConstraints#channelCount">channelCount</a></code> constraint is supported in the current environment.</dd>
 <dt>{{domxref("MediaTrackSupportedConstraints.deviceId", "deviceId")}}</dt>
 <dd>A Boolean value whose value is <code>true</code> if the <code><a href="/en-US/docs/Web/API/MediaTrackConstraints#deviceId">deviceId</a></code> constraint is supported in the current environment.</dd>
 <dt>{{domxref("MediaTrackSupportedConstraints.groupId", "groupId")}}</dt>
 <dd>A Boolean value whose value is <code>true</code> if the <code><a href="/en-US/docs/Web/API/MediaTrackConstraints#groupId">groupId</a></code> constraint is supported in the current environment.</dd>
</dl>

<h3 id="Properties_specific_to_shared_screen_tracks">Properties specific to shared screen tracks</h3>

<p>For tracks containing video sources from the user's screen contents, the following additional properties are may be included in addition to those available for video tracks.</p>

<dl>
 <dt>{{domxref("MediaTrackSupportedConstraints.cursor", "cursor")}}</dt>
 <dd>
 <p>A Boolean value which is <code>true</code> if the {{domxref("MediaTrackConstraints.cursor", "cursor")}} constraint is supported in the current environment.</p>
 </dd>
 <dt>{{domxref("MediaTrackSupportedConstraints.displaySurface", "displaySurface")}}</dt>
 <dd>
 <p>A Boolean value which is <code>true</code> if the {{domxref("MediaTrackConstraints.displaySurface", "cursor")}} constraint is supported in the current environment.</p>
 </dd>
 <dt>{{domxref("MediaTrackSupportedConstraints.logicalSurface", "logicalSurface")}}</dt>
 <dd>A Boolean value which is <code>true</code> if the {{domxref("MediaTrackConstraints.logicalSurface", "logicalSurface")}} constraint is supported in the current environment.</dd>
</dl>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaTrackSupportedConstraints")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API">Media Capture and Streams API</a></li>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API/Constraints">Capabilities, constraints, and settings</a></li>
 <li><a href="/en-US/docs/Web/API/Screen_Capture_API">Screen Capture API</a></li>
 <li><a href="/en-US/docs/Web/API/Screen_Capture_API/Using_Screen_Capture">Using the Screen Capture API</a></li>
 <li>{{domxref("MediaTrackConstraints")}}</li>
 <li>{{domxref("MediaDevices.getUserMedia()")}}</li>
 <li>{{domxref("MediaStreamTrack.getConstraints()")}}</li>
 <li>{{domxref("MediaStreamTrack.applyConstraints()")}}</li>
 <li>{{domxref("MediaStreamTrack.getSettings()")}}</li>
</ul>
